
TYPE pdata  'campi per ogni pianeta in pdata?.dat, i primi due bytes del file contengono ?
  race AS INTEGER
  id AS INTEGER
  friendlyCode AS STRING * 3
  mines AS INTEGER
  factories AS INTEGER
  defense AS INTEGER
  neutMined AS LONG
  tritMined AS LONG
  duraMined AS LONG
  molyMined AS LONG
  clans AS LONG
  supplies AS LONG
  mCredits AS LONG
  neutInGnd AS LONG
  tritInGnd AS LONG
  duraInGnd AS LONG
  molyInGnd AS LONG
  neutDens AS INTEGER
  tritDens AS INTEGER
  duraDens AS INTEGER
  molyDens AS INTEGER
  tax AS INTEGER
  taxNative AS INTEGER
  feel AS INTEGER
  feelNative AS INTEGER
  government AS INTEGER
  clansNative AS LONG
  raceNative AS INTEGER
  temperature AS INTEGER
  buildingBase AS INTEGER
END TYPE

TYPE xyplan  'campi con le coordinate dei pianeti in xyplan.dat
  x AS INTEGER
  y AS INTEGER
  zero AS INTEGER  'quasi sempre a zero?
END TYPE

TYPE race  'caratteristiche di ogni razza
  race AS INTEGER  'serve dopo che l'array e' stata ordinata
  rName AS STRING * 20
  exist AS INTEGER
  score AS INTEGER
END TYPE

TYPE messpntExt  'puntatori al file dei messaggi (i primi due bytes contengono il n. tot di messaggi)
  race AS INTEGER
  offset AS LONG
  lenght AS INTEGER
END TYPE

DEFINT A-Z
CONST radius = 1000
CONST halfRadius = radius / 2
DIM race(1 TO 11) AS race
DIM messagePointer AS messpntExt
DIM message(1 TO 16) AS STRING  '16 righe
DIM planet AS pdata
DIM planetCoord AS xyplan

'aggiusta la stringa del path
IF COMMAND$ = "" THEN path$ = "." ELSE path$ = COMMAND$
IF RIGHT$(path$, 1) <> "\" THEN path$ = path$ + "\"

PRINT CHR$(10); "Final Battle score"
PRINT "  Processing data in "; path$; CHR$(10)

'legge i nomi delle razze
OPEN path$ + "race.nm" FOR BINARY AS #1
SEEK #1, 11 * 30 + 1  'salta nomi lunghi
FOR i = 1 TO 11
  race(i).race = i
  GET #1, , race(i).rName
NEXT i
CLOSE #1

'controlla quali razze sono in gioco
OPEN path$ + "gen.hst" FOR BINARY AS #1
SEEK #1, &H2F  'posizione del flag della razza 1
FOR i = 1 TO 11
  GET #1, , race(i).exist
NEXT i
CLOSE #1

'legge il turno di gioco
OPEN path$ + "nextturn.hst" FOR BINARY AS #1
SEEK #1, &H13
GET #1, , turn
CLOSE #1

'calcola il punteggio
OPEN path$ + "pdata.hst" FOR BINARY AS #1
SEEK #1, 3
OPEN path$ + "xyplan.dat" FOR BINARY AS #2
FOR i = 1 TO 500
  GET #1, , planet
  GET #2, , planetCoord
  IF planet.race <> 0 THEN
    dx = planetCoord.x - 2000
    dy = planetCoord.y - 2000
    distance = SQR(CLNG(dx) * dx + CLNG(dy) * dy)  'distanza dal centro
    distance = ABS(halfRadius - distance)  'distanza dalla meta' tra centro e bordo
    'score =30 se d=0 (a meta' tra centro e bordo), =10 se d=r/2 (al centro e al bordo)
    score = 10 + (20 * (halfRadius - distance) / halfRadius)
    'il punteggio verra' diviso per 10 successivamente per evitare un problema di arrotondamenti
    race(planet.race).score = race(planet.race).score + score
  END IF
NEXT i
CLOSE #1, #2

'ordina per score
FOR i = 2 TO 11
  FOR j = i TO 2 STEP -1
    IF race(j - 1).score < race(j).score THEN
      SWAP race(j - 1), race(j)
    ELSE
      EXIT FOR
    END IF
  NEXT j
NEXT i
'da questo punto in poi la razza 1 e' la prima in classifica e non i fed

'prepara il testo del messaggio
message(1) = "<<< PUNTEGGIO >>>" + CHR$(13)
message(2) = "" + CHR$(13)
message(3) = "Turno" + STR$(turn) + CHR$(13)
message(4) = "" + CHR$(13)
line. = 4
FOR i = 1 TO 11
  IF race(i).exist THEN
    line. = line. + 1
    'il punteggio  diviso per 10 e scritto sempre con un decimale
    score$ = RIGHT$(SPACE$(4) + STR$(race(i).score \ 10), 4)
    score$ = score$ + "." + RIGHT$(STR$(race(i).score MOD 10), 1)
    message(line.) = race(i).rName + " " + score$ + CHR$(13)
  END IF
NEXT i
totalLines = line.

'scrive il .log e stampa a video
OPEN path$ + "fbscore.log" FOR OUTPUT AS #1
FOR line. = 2 TO totalLines
  PRINT message(line.);
  PRINT #1, message(line.); CHR$(10);
NEXT line.
PRINT
CLOSE #1

'codifica il testo
messageLenght = 0
FOR line. = 1 TO totalLines
  FOR c = 1 TO LEN(message(line.))
    MID$(message(line.), c, 1) = CHR$(ASC(MID$(message(line.), c, 1)) + &HD)
  NEXT c
  messageLenght = messageLenght + LEN(message(line.))
NEXT line.
 
OPEN path$ + "messpnt.ext" FOR BINARY AS #1
OPEN path$ + "mess.ext" FOR BINARY AS #2

'posiziona il puntatore del file
GET #1, , totalMessages
IF totalMessages = 0 THEN
  messagePointer.offset = 1
  SEEK #1, 3
ELSE
  GET #1, 3 + CLNG((totalMessages - 1)) * LEN(messagePointer), messagePointer
  messagePointer.offset = messagePointer.offset + messagePointer.lenght
END IF

'scrive i messaggi
SEEK #2, messagePointer.offset
messagePointer.lenght = messageLenght
FOR i = 1 TO 11
  IF race(i).exist THEN
    messagePointer.race = race(i).race
    FOR line. = 1 TO totalLines
      PUT #2, , message(line.)
    NEXT line.
    PUT #1, , messagePointer
    totalMessages = totalMessages + 1
    messagePointer.offset = messagePointer.offset + messagePointer.lenght
  END IF
NEXT i
PUT #1, 1, totalMessages

CLOSE #1, #2

